package com.lsw.captcha.react;

import android.widget.Toast;

import com.facebook.react.bridge.Promise;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.lsw.captcha.CaptchaUtil;

public class CaptchaModule extends ReactContextBaseJavaModule {

    private CaptchaUtil mAuthSliderTip;
    public CaptchaModule(ReactApplicationContext reactContext) {
        super(reactContext);
    }

    @Override
    public String getName() {
        return "LSCaptcha";
    }


    @ReactMethod
    public void showCaptcha(String mobile,int type,final Promise promise){
        mAuthSliderTip = CaptchaUtil.getNewInstance().
                setParameter(mobile, type)
                .setCaptchaCallback(new CaptchaUtil.CaptchaCallback() {
                    @Override
                    public void onVerifyFail(String message) {
                        Toast.makeText(getReactApplicationContext(),message,Toast.LENGTH_LONG).show();
                        promise.reject("-1",message);
                    }

                    @Override
                    public void onVerifySuccess(String message, boolean needRegister, int status) {
                        Toast.makeText(getReactApplicationContext(),message,Toast.LENGTH_LONG).show();
                        promise.resolve(message);
                    }
                }).show(getCurrentActivity());
    }


}
