package com.lsw.captcha.web;

import android.annotation.SuppressLint;
import android.content.Context;
import android.os.Build;
import android.support.annotation.RequiresApi;
import android.util.AttributeSet;
import android.webkit.WebSettings;
import android.webkit.WebView;

public class LsWebView extends WebView {
    public LsWebView(Context context) {
        super(context);initSettings();
    }

    public LsWebView(Context context, AttributeSet attrs) {
        super(context, attrs);initSettings();
    }

    public LsWebView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);initSettings();
    }

    @RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
    public LsWebView(Context context, AttributeSet attrs, int defStyleAttr, int defStyleRes) {
        super(context, attrs, defStyleAttr, defStyleRes);initSettings();
    }

    @SuppressLint("SetJavaScriptEnabled")
    private void initSettings() {
        WebSettings settings = getSettings();
        settings.setJavaScriptEnabled(true);
        //让WebView支持可任意比例缩放
        settings.setUseWideViewPort(true);
        //打开WebView缓存功能
        settings.setAppCacheEnabled(true);
        settings.setAllowFileAccess(true);

        settings.setAllowFileAccessFromFileURLs(true);
        //设置脚本是否允许自动打开弹窗
        settings.setJavaScriptCanOpenWindowsAutomatically(true);

        // 加快HTML网页加载完成速度
        if (Build.VERSION.SDK_INT >= 19) {
            settings.setLoadsImagesAutomatically(true);
        } else {
            settings.setLoadsImagesAutomatically(false);
        }
        if (Build.VERSION.SDK_INT >= 21) {
            settings.setMixedContentMode( WebSettings.MIXED_CONTENT_ALWAYS_ALLOW );
        }

        //让WebView支持DOM storage API
        settings.setDomStorageEnabled(true);
    }
}