//
//  LSCaptcha.m
//  LSCaptcha
//
//  Created by Dylan on 2018/10/31.
//  Copyright © 2018 Yang. All rights reserved.
//

#import "LSCaptcha.h"
#import "NSString+LSConvert.h"

#import "UIView+WhenTappedBlocks.h"

@implementation LSCaptcha

RCT_EXPORT_MODULE();


RCT_EXPORT_METHOD(show:(NSString *)url success:(RCTPromiseResolveBlock)success failure:(RCTResponseErrorBlock)failure){
    
    dispatch_sync(dispatch_get_main_queue(), ^{
        [self loadWebView:url success:success];
    });
}




-(void)loadWebView:(NSString *)webUrl success:(RCTPromiseResolveBlock)success{
    
    self.promiseResolveBlock = success;
    NSTimeInterval time = [[NSDate date] timeIntervalSince1970] * 1000;
    NSString *timeStr = [NSString stringWithFormat:@"%lf",time];
    if (timeStr.length >13) {
        timeStr = [timeStr substringToIndex:13];
    }

    
    NSString* url = [NSString stringWithFormat:@"%@%@",webUrl, timeStr];
    UIWindow* window = [UIApplication sharedApplication].keyWindow;
    
    
    LSWebViewBridge *webView = [[LSWebViewBridge alloc]initWithFrame:CGRectMake(0, 0, ([[UIScreen mainScreen]bounds].size.width) - 40, 220)];
    webView.center = window.center;
    webView.delegate = self;
    webView.url = url;
    [window addSubview:webView];
    self.webView = webView;
    [window whenTapped:^{
        [webView removeFromSuperview];
    }];
}


// * 9-注册，0-找回密码、修改密码，1-登录、快速登录
-(void) jsCallNativeAction:(NSString *)action param:(NSString *)param{
    
    NSDictionary *dic = [NSString dictionaryWithJsonString:param];
    if ([action isEqualToString:@"methodGetSms"]) {
        NSMutableDictionary *dic = [NSMutableDictionary dictionary];
        [dic setObject:self.mobile forKey:@"mobile"];
        [dic setObject:@"1" forKey:@"actType"];
        NSString *jsonStr = [NSString dictionaryToJson:dic];
        [self.webView callJavaScript:[NSString stringWithFormat:@"bridgeResponse('%@','%@');",action,jsonStr] responseBlock:^(NSString * _Null_unspecified response) {
        }];
    }else if ([action isEqualToString:@"methodPushMessage"]){
        [self.webView removeFromSuperview];
//        [LSAlertViewUtil showMessage:param];
    }else if ([action isEqualToString:@"methodSmsSuccess"]){
        [self.webView removeFromSuperview];
//        [LSAlertViewUtil showMessage:dic[@"message"]];
        // 发送验证码、开始倒计时

        
        NSString* isRegister = dic[@"isRegister"];
        
        self.promiseResolveBlock(isRegister);
        
//        if ([dic[@"isRegister"] integerValue] == 1) { // 未注册
////
////            self.isRegister = NO;
////            _loginBtnView.frame = CGRectMake(0, MaxY(_protocolView) + 23, kScreenWidth, 100);
////            _scrollView.contentSize = CGSizeMake(0, MaxY(_loginBtnView));
//        }else if([dic[@"isRegister"] integerValue] == 0){// 已注册
////            self.isRegister = YES;
////            _loginBtnView.frame = CGRectMake(0, MaxY(_verifyCodeTextField) + 23, kScreenWidth, 100);
////            _scrollView.contentSize = CGSizeMake(0, MaxY(_verifyCodeTextField));
//        }
    }
}


//NSTimeInterval time = [[NSDate date] timeIntervalSince1970] * 1000;
//NSString *timeStr = [NSString stringWithFormat:@"%lf",time];
//if (timeStr.length >13) {
//    timeStr = [timeStr substringToIndex:13];
//}
//[self loadWebView:[NSString stringWithFormat:@"%@subject/service/sms.html?t=%@",[LSUserDefaultsTool objectForKey:LSMsiteBaseURL], timeStr]];




@end
