//
//  LSWebViewBridge.h
//  LSBuyer
//
//  Created by Li Zhiyu on 16/10/12.
//  Copyright © 2016年 lianshang. All rights reserved.
//

#import <UIKit/UIKit.h>
//#import "UIView+LSNativeBradgeAction.h"
#import <WebKit/WebKit.h>

typedef void (^NativeCallJSResponse)(NSString * _Null_unspecified response);

@protocol LSWebViewBridgeDelegate <NSObject>

@optional

//js 调用native方法
-(void)jsCallNativeAction:(NSString* __nonnull)action param:(NSString* __nonnull)param;

//获取到html标题
-(void)htmlTitle:(NSString* __nonnull)title;

@end

@interface LSWebViewBridge : UIView

@property(retain,nonatomic) WKWebView *wkWebView;


@property(nonatomic,assign) id<LSWebViewBridgeDelegate> delegate;

@property(nonatomic,strong) NSString *url;

@property(nonatomic,strong) NSString *currentUrl;
//

/*
 *@brief LSWebViewBridge 调用js方法请用这个  
 *js func uiGetOut(); 或 uiGetOut('adf'); 或 uiGetOut('adf','123');  uiGetOut是js方法
 *
 */
-(void)callJavaScript:(NSString*__nonnull)func responseBlock:(NativeCallJSResponse _Null_unspecified)responseBlock;

/*
 *@brief LSWebViewBridge 调用js 回调 方法请用这个  就相当于调用js 这个bridgeResponse方法
 *action 就是js调用native给你的action
 *param  回调参数给js
 */
-(void)callJavaScriptBridgeResponse:(NSString * __nonnull)action param:(NSString* __nonnull)param responseBlock:(NativeCallJSResponse _Null_unspecified)responseBlock;

@end
