//
//  NSObject+LSNativeBradgeAction.m
//  LSBuyer
//
//  Created by Li Zhiyu on 16/6/17.
//  Copyright © 2016年 lianshang. All rights reserved.
//

#import "UIView+LSNativeBradgeAction.h"
#import <WebKit/WebKit.h>


@implementation UIView (LSNativeBradgeAction)

#pragma -mark 解析交互action和参数
-(BOOL)nativeAction:(NSString *)action param:(NSString *)param{
    NSDictionary *paramDict=nil;
    
    if(param && [param isKindOfClass:[NSString class]]&&param.length>0){
        paramDict=[self dictionaryWithJsonString:param];
    }
    
    
    BOOL isCallJS=YES;
    
    BOOL isExed=YES;
    
    
    if ([action isEqualToString:@"methodGetAppUserInfo"]){
        isCallJS=NO;
        
        [self callJSResponseAction:action param:[self getAppInfoUser] responseBlock:nil];
        return isExed;
        
    }else{
        isExed=NO;
    }
    
    if(isCallJS&&isExed){
        [self callJSResponseAction:action param:@"success" responseBlock:nil];
    }
    
    return isExed;
    
    
}

-(void)shareSuccess:(NSNotification*)notify{
    
}


-(NSString*)getAppInfoUser{
    NSMutableDictionary *appUserInfo=[NSMutableDictionary new];
//    [appUserInfo setObject:[[LSGetUDID sharedLSGetUDID]readUDID] forKey:@"deviceId"];
//    [appUserInfo setObject:[[[NSBundle mainBundle] infoDictionary] objectForKey:@"CFBundleShortVersionString"] forKey:@"appVersion"];
//    [appUserInfo setObject:[NSString stringWithFormat:@"iOS-%@",[[LSGetUDID sharedLSGetUDID] fetchIDFVIdentifier]] forKey:@"clientCodeLS"];
//    NSString *token=[AccountTool sharedAccountTool].account.token;
//    if(!token||[token isKindOfClass:[NSNull class]]){
//        token=@"";
//    }
//    NSString *userId=[[LSUserDI new] getCacheUserInfo].userId;
//    if(!userId||[userId isKindOfClass:[NSNull class]]){
//        userId=@"";
//    }
//    [appUserInfo setObject:token forKey:@"token"];
//    [appUserInfo setObject:userId forKey:@"userId"];
//    [appUserInfo setObject:[UIDevice currentDevice].systemVersion forKey:@"platformVersion"];
//    [appUserInfo setObject:[UIDevice currentDevice].model forKey:@"deviceModel"];
//    [appUserInfo setObject:[LSGetDeviceType getDeviceType] forKey:@"deviceType"];
//
    NSString *appInfoStr=[self jsonFromDic:appUserInfo];
    return appInfoStr;
}








#pragma -mark 调用function并传入参数
-(void)callJSFunction:(NSString *)function param:(NSString *)param{
    NSString *func=[NSString stringWithFormat:@"%@('%@');",function,param];
    if(param&&param.length>0){
        func=[NSString stringWithFormat:@"%@();",function];
    }
    
    [self callFunction:func responseBlock:nil];
    
}

#pragma -mark js调用native  native响应给js
-(void)callJSResponseAction:(NSString*)action param:(NSString*)param responseBlock:(NativeCallJSResponse _Null_unspecified)responseBlock{
    [self callFunction:[NSString stringWithFormat:@"bridgeResponse('%@','%@');",action,param] responseBlock:responseBlock];
}

#pragma -mark 调用JS方法如  test('aa');
-(void)callFunction:(NSString*)function responseBlock:(NativeCallJSResponse _Null_unspecified)responseBlock{
    function=[function stringByReplacingOccurrencesOfString:@"\r" withString:@""];
    function=[function stringByReplacingOccurrencesOfString:@"\t" withString:@""];
    function=[function stringByReplacingOccurrencesOfString:@"\n" withString:@""];
    function=[function stringByReplacingOccurrencesOfString:@" " withString:@""];
    function=[function stringByReplacingOccurrencesOfString:@"\\" withString:@""];
        
    if([self isKindOfClass:[UIWebView class]]){
        UIWebView *webView=(UIWebView*)self;
        if ([[NSThread currentThread] isMainThread]) {
            NSString *res = [webView stringByEvaluatingJavaScriptFromString:function];
            if(responseBlock){
                responseBlock(res);
            }
        }else{
             dispatch_sync(dispatch_get_main_queue(), ^{
                 NSString *res = [webView stringByEvaluatingJavaScriptFromString:function];
                 if(responseBlock){
                     responseBlock(res);
                 }
             });
        }
    }else if([self isKindOfClass:[WKWebView class]]){
        WKWebView *webView=(WKWebView*)self;
        if ([[NSThread currentThread] isMainThread]) {
            [webView evaluateJavaScript:function completionHandler:^(id _Nullable response, NSError * _Nullable error) {
                NSLog(@"response: %@ error: %@", response, error);
                NSLog(@"call js alert by native");
                if(responseBlock){
                    responseBlock(response);
                }
            }];
        }else{
            dispatch_sync(dispatch_get_main_queue(), ^{
                [webView evaluateJavaScript:function completionHandler:^(id _Nullable response, NSError * _Nullable error) {
                    NSLog(@"response: %@ error: %@", response, error);
                    NSLog(@"call js alert by native");
                    if(responseBlock){
                        responseBlock(response);
                    }
                }];
            });
        }
    }
}


- (NSMutableDictionary *)dictionaryWithJsonString:(NSString *)jsonString {
    if (jsonString == nil) {
        return nil;
    }
    
    NSData              *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    NSError             *err;
    NSMutableDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData
                                                               options:NSJSONReadingMutableContainers
                                                                 error:&err];
    if (err) {
        NSLog(@"json解析失败：%@", err);
        return nil;
    }
    return dic;
}

- (NSString *)jsonFromDic:(NSDictionary *)muDict {
    NSString *jsonStr;
    // IOS 自带对象json
    if ([NSJSONSerialization isValidJSONObject:muDict]) { // 判断 可不可以转JSon
        NSError       *error;
        NSData        *jsonData    = [NSJSONSerialization dataWithJSONObject:muDict options:NSJSONWritingPrettyPrinted error:&error];
        NSMutableData *temJsonData = [NSMutableData dataWithData:jsonData];
        
        jsonStr = [[NSString alloc] initWithData:temJsonData encoding:NSUTF8StringEncoding];
    }
    return jsonStr;
}


- (UIViewController *)findViewController
{
    id target=self;
    while (target) {
        target = ((UIResponder *)target).nextResponder;
        if ([target isKindOfClass:[UIViewController class]]) {
            break;
        }
    }
    return target;
}

@end
